local level_id = Global.level_data and Global.level_data.level_id or ""
local difficulty = Global.game_settings and Global.game_settings.difficulty or "easy"

-- Fix some access related issues
-- Deprecated
--[[
Hooks:PostHook(CopBrain, "init", "pd3_init_cop", function(self, unit)
	if managers.groupai:state():whisper_mode() then
		if self._SO_access ~= "security" or self._SO_access ~= "security_patrol" or self._SO_access ~= "cop" or self._SO_access ~= "gangster" then
			self._SO_access = managers.navigation:convert_access_flag(tweak_data.character.security.access)
		end
	end
end)
]]

-- Each time a new guard instance is created, there is a 0.05 chance on all difficulties it won't carry a pager
Hooks:PostHook(CopBrain, "post_init", "_pager_chances", function(self)
	if self._unit:base()._tweak_table == "security" then
		if math.random() < 0.05 and self._unit:unit_data().has_alarm_pager then
			self._unit:unit_data().has_alarm_pager = false
		end
	end
end)

local GUARD_LIMIT = {
	["arm_for"] = 4,
	["tag"] = 4,
	["deep"] = 4,
	["corp"] = 4,
	["ranc"] = 6,
	["sand"] = 6,
	["hox_3"] = 4,
}

local num_guards_killed = 0

Hooks:PostHook(CopBrain, "clbk_death", "_init_death_ralph_trigger_search_mode", function(self)
	-- If birthday boy is ded, guards will be suspicious and will search the area
	if level_id == "dah" and self._unit:name():key() == Idstring("units/pd2_dlc_dah/characters/npc_male_ralph/npc_male_ralph"):key() then
		if managers.groupai:state():whisper_mode() and not managers.groupai:state():is_search_mode_active() then
			DelayedCalls:Add("_func_ralph_search_mode", 15, function()
				if managers.groupai:state():whisper_mode() and not managers.groupai:state():is_search_mode_active() then
					managers.groupai:state():set_search_mode(true, "SECURITY NOTICED RALPH IS MISSING")
				end
			end)
		end
	end
	
	-- Trigger a search on certain levels with a kill-limit
	if GUARD_LIMIT[level_id] and managers.groupai:state():whisper_mode() then
		num_guards_killed = num_guards_killed + 1
		
		if num_guards_killed >= GUARD_LIMIT[level_id] then
			if not managers.groupai:state():is_search_mode_active() then
				DelayedCalls:Add("_func_guard_limit_search_mode", 8, function()
					if managers.groupai:state():whisper_mode() and not managers.groupai:state():is_search_mode_active() then
						managers.groupai:state():set_search_mode(true, "SECURITY IS NOW SEARCHING FOR THE MISSING CREW")
					end
				end)
			end
		end
	end
end)