local level_id = Global.level_data and Global.level_data.level_id or ""

Hooks:OverrideFunction(CopLogicIntimidated, "_chk_begin_alarm_pager", function(data)
	local is_stealth = managers.groupai:state():whisper_mode()
	local has_pager = data.unit:unit_data().has_alarm_pager
	local can_activate_pager = is_stealth and data.unit:unit_data().has_active_radio or is_stealth and level_id == "vit"
	if has_pager and can_activate_pager then
		data.brain:begin_alarm_pager()
	end
end)

local function func_onIntimidated(data, amount, aggressor_unit)
	local my_data = data.internal_data

	if not my_data.tied then
		my_data.surrender_break_t = data.char_tweak.surrender_break_time and data.t + math.random(data.char_tweak.surrender_break_time[1], data.char_tweak.surrender_break_time[2], math.random())
		local anim_data = data.unit:anim_data()
		local anim, blocks = nil

		if anim_data.hands_up then
			anim = "hands_back"
			blocks = {
				heavy_hurt = -1,
				hurt = -1,
				action = -1,
				light_hurt = -1,
				walk = -1
			}
		elseif anim_data.hands_back then
			anim = "tied"
			blocks = {
				heavy_hurt = -1,
				hurt_sick = -1,
				action = -1,
				light_hurt = -1,
				hurt = -1,
				walk = -1
			}
		else
			anim = "tied_all_in_one"

			blocks = {
				heavy_hurt = -1,
				hurt = -1,
				action = -1,
				light_hurt = -1,
				walk = -1
			}
		end

		local action_data = {
			clamp_to_graph = true,
			type = "act",
			body_part = 1,
			variant = anim,
			blocks = blocks
		}
		local act_action = data.unit:brain():action_request(action_data)

		if data.unit:anim_data().hands_tied then
			CopLogicIntimidated._do_tied(data, aggressor_unit)
		end
	end
end

local on_intimidated = Hooks:GetFunction(CopLogicIntimidated, "on_intimidated")
Hooks:OverrideFunction(CopLogicIntimidated, "on_intimidated", function(data, amount, aggressor_unit)
	if data.unit:unit_data().is_civilian then
		func_onIntimidated(data, amount, aggressor_unit)
	else
		on_intimidated(data, amount, aggressor_unit)
	end
end)

local function func_ActionHandsUp(data)
	local my_data = data.internal_data
	local anim_name = "tied_all_in_one"
	local action_data = {
		clamp_to_graph = true,
		type = "act",
		body_part = 1,
		variant = anim_name,
		blocks = {
			light_hurt = -1,
			hurt = -1,
			heavy_hurt = -1,
			walk = -1
		}
	}
	my_data.act_action = data.unit:brain():action_request(action_data)

	if my_data.act_action and data.unit:anim_data().hands_tied then
		CopLogicIntimidated._do_tied(data, my_data.aggressor_unit)
	end
end

local _start_action_hands_up = Hooks:GetFunction(CopLogicIntimidated, "_start_action_hands_up")
Hooks:OverrideFunction(CopLogicIntimidated, "_start_action_hands_up", function(data)
	if data.unit:unit_data().is_civilian then
		func_ActionHandsUp(data)
	else
		_start_action_hands_up(data)
	end
end)

Hooks:PostHook(CopLogicIntimidated, "_do_tied", "_set_as_civvie", function(data)
	if not data.unit:unit_data().is_civilian then
		data.unit:unit_data().is_civilian = true
	end
end)

Hooks:PostHook(CopLogicIntimidated, "on_rescue_SO_completed", "_on_freed", function(ignore_this, data, good_pig)
	local is_security = data.unit:base()._tweak_table == "security" or data.unit:base()._tweak_table == "gensec"
	if not is_security then
		if data.unit:unit_data().is_civilian then
			data.unit:unit_data().is_civilian = nil
		end
	else
		if not managers.groupai:state():is_enemy_assigned(data) then
			managers.groupai:state():assign_enemy_to_group_ai(data.unit, "neutral1")
		end
	end
end)