local level_id = Global.level_data and Global.level_data.level_id or ""

if Global.editor_mode or level_id == "modders_devmap" or level_id == "Enemy_Spawner" then
	return
end

-- Taken from SH, but serves different purpose: difficulty-specific guard spawns
-- Basically, any guard provided by gensec will have it's model change depending on difficulty
-- So you will have ordinary mall cops on normal-hard but you will have Gensec SWATs on higher difficulties
-- Certain maps have their own guards, but should some guard affiliated with gensec exist, they will be switched
-- to their swat variants on higher difficulties.
local enemy_replacements = {
	overkill_145 = {
		security_1 = "units/payday2/characters/ene_city_swat_3/ene_city_swat_3",
		security_2 = "units/payday2/characters/ene_city_swat_3/ene_city_swat_3",
	},
	overkill_290 = {
		security_1 = "units/payday2/characters/ene_city_swat_1/ene_city_swat_1",
		security_2 = "units/payday2/characters/ene_city_swat_2/ene_city_swat_2",
		security_3 = "units/payday2/characters/ene_city_swat_3/ene_city_swat_3",
	},
	easy_wish = {
		security_1 = "units/payday2/characters/ene_city_swat_1/ene_city_swat_1",
		security_2 = "units/payday2/characters/ene_city_swat_2/ene_city_swat_2",
		security_3 = "units/payday2/characters/ene_city_swat_3/ene_city_swat_3",
	},
	sm_wish = {
		security_1 = "units/payday2/characters/ene_city_swat_1/ene_city_swat_1",
		security_2 = "units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3",
		security_3 = "units/payday2/characters/ene_city_swat_3/ene_city_swat_3",
	},
	-- Faction Overrides
	response_type_gensec = {
		swat_1 = "units/payday2/characters/ene_city_swat_1/ene_city_swat_1",
		swat_2 = "units/payday2/characters/ene_city_swat_r870/ene_city_swat_r870",
		heavy_swat_1 = "units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36",
		heavy_swat_r870 = "units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870",
		dozer_1 = "units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3",
		dozer_2 = "units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3",
		shield_1 = "units/payday2/characters/ene_city_shield/ene_city_shield",
		shield_2 = "units/payday2/characters/ene_city_shield/ene_city_shield"
	},
	response_type_bellmead = {
		shield_1 = "units/pd2_dlc_usm1/characters/ene_male_marshal_shield_2/ene_male_marshal_shield_2",
		shield_2 = "units/pd2_dlc_usm1/characters/ene_male_marshal_shield_2/ene_male_marshal_shield_2",
		sniper_1 = "units/pd2_dlc_usm1/characters/ene_male_marshal_marksman_2/ene_male_marshal_marksman_2",
		sniper_2 = "units/pd2_dlc_usm1/characters/ene_male_marshal_marksman_2/ene_male_marshal_marksman_2",
		swat_1 = "units/pd2_dlc_deep/characters/ene_deep_security_1/ene_deep_security_1",
		swat_2 = "units/pd2_dlc_deep/characters/ene_deep_security_2/ene_deep_security_2",
		heavy_swat_1 = "units/pd2_dlc_deep/characters/ene_deep_security_3/ene_deep_security_3",
		heavy_swat_r870 = "units/pd2_dlc_deep/characters/ene_deep_security_3/ene_deep_security_3"
	},
	response_type_fbi = {
		cop_1 = "units/payday2/characters/ene_fbi_1/ene_fbi_1",
		cop_2 = "units/payday2/characters/ene_fbi_2/ene_fbi_2",
		cop_3 = "units/payday2/characters/ene_fbi_3/ene_fbi_3",
		swat_1 = "units/payday2/characters/ene_fbi_swat_1/ene_fbi_swat_1",
		swat_2 = "units/payday2/characters/ene_fbi_swat_2/ene_fbi_swat_2",
		heavy_swat_1 = "units/payday2/characters/ene_fbi_heavy_1/ene_fbi_heavy_1",
		heavy_swat_r870 = "units/payday2/characters/ene_fbi_heavy_r870/ene_fbi_heavy_r870",
		shield_1 = "units/payday2/characters/ene_shield_1/ene_shield_1",
		shield_2 = "units/payday2/characters/ene_shield_1/ene_shield_1",
		sniper_1 = "units/payday2/characters/ene_sniper_2/ene_sniper_2"
	},
	murkywater = {
		sniper_1 = "units/pd2_dlc_bph/characters/ene_murkywater_sniper/ene_murkywater_sniper",
		sniper_2 = "units/pd2_dlc_bph/characters/ene_murkywater_sniper/ene_murkywater_sniper",
		shield_1 = "units/pd2_dlc_bph/characters/ene_murkywater_shield/ene_murkywater_shield",
		shield_2 = "units/pd2_dlc_bph/characters/ene_murkywater_shield/ene_murkywater_shield"
	}
}
local enemy_mapping = {
	[Idstring("units/payday2/characters/ene_security_1/ene_security_1"):key()] = "security_1",
	[Idstring("units/payday2/characters/ene_security_2/ene_security_2"):key()] = "security_2",
	[Idstring("units/payday2/characters/ene_security_3/ene_security_3"):key()] = "security_3",
	-- Swat replacements
	[Idstring("units/payday2/characters/ene_cop_1/ene_cop_1"):key()] = "cop_1",
	[Idstring("units/payday2/characters/ene_cop_2/ene_cop_2"):key()] = "cop_2",
	[Idstring("units/payday2/characters/ene_cop_3/ene_cop_3"):key()] = "cop_3",
	[Idstring("units/payday2/characters/ene_cop_4/ene_cop_4"):key()] = "cop_4",
	[Idstring("units/payday2/characters/ene_swat_1/ene_swat_1"):key()] = "swat_1",
	[Idstring("units/payday2/characters/ene_swat_2/ene_swat_2"):key()] = "swat_2",
	[Idstring("units/payday2/characters/ene_swat_heavy_1/ene_swat_heavy_1"):key()] = "heavy_swat_1",
	[Idstring("units/payday2/characters/ene_swat_heavy_r870/ene_swat_heavy_r870"):key()] = "heavy_swat_r870",
	[Idstring("units/payday2/characters/ene_shield_1/ene_shield_1"):key()] = "shield_1",
	[Idstring("units/payday2/characters/ene_shield_2/ene_shield_2"):key()] = "shield_2",
	[Idstring("units/payday2/characters/ene_bulldozer_1/ene_bulldozer_1"):key()] = "dozer_1",
	[Idstring("units/payday2/characters/ene_bulldozer_2/ene_bulldozer_2"):key()] = "dozer_2",
	[Idstring("units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3"):key()] = "dozer_3",
	[Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1"):key()] = "sniper_1",
	[Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2"):key()] = "sniper_2",
}

local difficulty
local group_ai = tweak_data.levels[level_id] and tweak_data.levels[level_id].ai_group_type
if tweak_data.levels[level_id] and tweak_data.levels[level_id].group_ai_state == "skirmish" then
	difficulty = "normal"
else
	difficulty = Global.game_settings and Global.game_settings.difficulty or "normal"
end

Hooks:PostHook(ElementSpawnEnemyDummy, "init", "_difficulty_specific_guards", function(self)
	local has_anim = self._values.spawn_action and self._values.spawn_action ~= "none"
	local mapped_name = enemy_mapping[self._enemy_name:key()]
	if mapped_name and has_anim then -- Skip if the specified enemy is playing anims
		return
	end
	
	local mapped_unit = enemy_replacements[difficulty] and enemy_replacements[difficulty][mapped_name] or enemy_replacements[group_ai] and enemy_replacements[group_ai][mapped_name]
	local mapped_unit_ids = mapped_unit and Idstring(mapped_unit)
	if mapped_unit_ids and mapped_unit_ids ~= self._enemy_name then
		self._enemy_name = mapped_unit_ids
	end
	
	-- Override specific enemies
	if level_id == "pex" then
		self._values.participate_to_group_ai = false
	end
	
	if level_id == "vit" then
		
		if self:id() == 100673 or self:id() == 100672 then
			if managers.groupai:state():is_difficulty_greater() then
				self._enemy_name = Idstring("units/payday2/characters/ene_murkywater_1/ene_murkywater_1")
				self._is_elite = true
			end
		elseif self:id() == 101198 then
			self._enemy_name = Idstring("units/pd2_dlc_bph/characters/ene_murkywater_light/ene_murkywater_light")
			self._is_elite = true
			self._values.participate_to_group_ai = false
		end
	elseif level_id == "arm_for" then
		if managers.groupai:state():is_difficulty_greater() then
			self._enemy_name = Idstring("units/payday2/characters/ene_city_swat_3/ene_city_swat_3")
			self._is_elite = true
			self._values.participate_to_group_ai = true
		end
	end
end)

Hooks:PostHook(ElementSpawnEnemyDummy, "_finalize_values", "pd3_update_teams", function(self)
	if level_id == "ranc" then
		local mobs = {
			[Idstring("units/pd2_dlc_ranc/characters/ene_male_ranc_security_1/ene_male_ranc_security_1"):key()] = true,
			[Idstring("units/pd2_dlc_ranc/characters/ene_male_ranc_security_2/ene_male_ranc_security_2"):key()] = true,
			[Idstring("units/pd2_dlc_ranc/characters/ene_male_ranchmanager_1/ene_male_ranchmanager_1"):key()] = true,
			[Idstring("units/pd2_dlc_ranc/characters/ene_male_ranc_ranger_01/ene_male_ranc_ranger_01"):key()] = true,
			[Idstring("units/pd2_dlc_ranc/characters/ene_male_ranc_ranger_02/ene_male_ranc_ranger_02"):key()] = true,
		}
		
		if mobs[self._enemy_name:key()] then
			self._values.team = "mobster1"
		end
	elseif level_id == "pent" then
		local mobs = {
			[Idstring("units/pd2_dlc_pent/characters/ene_male_triad_penthouse_1/ene_male_triad_penthouse_1"):key()] = true,
			[Idstring("units/pd2_dlc_pent/characters/ene_male_triad_penthouse_2/ene_male_triad_penthouse_2"):key()] = true,
			[Idstring("units/pd2_dlc_pent/characters/ene_male_triad_penthouse_3/ene_male_triad_penthouse_3"):key()] = true,
			[Idstring("units/pd2_dlc_pent/characters/ene_male_triad_penthouse_4/ene_male_triad_penthouse_4"):key()] = true,
			[Idstring("units/pd2_dlc_pent/characters/ene_male_security_penthouse_1/ene_male_security_penthouse_1"):key()] = true,
			[Idstring("units/pd2_dlc_pent/characters/ene_male_security_penthouse_2/ene_male_security_penthouse_2"):key()] = true,
		}
		
		if mobs[self._enemy_name:key()] then
			self._values.team = "mobster1"
		end
	elseif level_id == "vit" then
		-- Used to make specific murkies be oblivious to your disguise without making every single one of them suspect you
		-- This map will have additional code to make neutral1 became hostile
		if self:id() == 101200 or self:id() == 101198 then
			self._values.team = "neutral1"
		end
	end
end)