GroupAIStateBesiege._MAX_SIMULTANEOUS_SPAWNS = 4

Hooks:OverrideFunction(GroupAIStateBesiege, "_check_spawn_phalanx", function(self)
	return false
end)

Hooks:OverrideFunction(GroupAIStateBesiege, "assign_enemy_to_group_ai", function(self, unit, team_id)
	local u_tracker = unit:movement():nav_tracker()
	local seg = u_tracker:nav_segment()
	local area = self:get_area_from_nav_seg_id(seg)
	
	-- Units assigned to 'map_spawned_persistent' will remain participating in the assault or recon phases
	-- while units assigned to 'map_spawned' will retire during assaults
	local function getType()
		-- Cops spawned by mission scripts will just be persistent
		if unit:base()._tweak_table == "cop" then
			return "map_spawned_persistent"
		end
		
		-- If snipers somehow get added to group ai which shouldn't be the case normally, add them to map_spawned_persistent instead
		-- I tried Cook Off, somehow the snipers got assigned to group AI so just in-case the game doesn't retire or despawn them
		-- they are assigned to a group that will stay on both recon/assault phases
		if unit:base()._tweak_table == "sniper" then
			return "map_spawned_persistent"
		end
		
		return "map_spawned"
	end
	
	local group_desc = {
		size = 1,
		type = getType()
	}
	local group = self:_create_group(group_desc)
	group.team = self._teams[team_id]
	local grp_objective = nil
	local objective = unit:brain():objective()
	local grp_obj_type = self._task_data.assault.active and "assault_area" or "recon_area"

	if objective then
		grp_objective = {
			type = grp_obj_type,
			area = objective.area or objective.nav_seg and self:get_area_from_nav_seg_id(objective.nav_seg) or area
		}
		objective.grp_objective = grp_objective
	else
		grp_objective = {
			type = grp_obj_type,
			area = area
		}
	end
	
	if self._task_data.assault.is_first and not self._task_data.assault.active then
		if unit:base()._tweak_table == "cop" or unit:base()._tweak_table == "fbi" then
			grp_objective.type = "reenforce_area"
			
			if objective then
				objective.grp_objective.type = grp_objective.type
			end
		end
	end

	grp_objective.moving_out = false
	group.objective = grp_objective
	group.has_spawned = true

	self:_add_group_member(group, unit:key())
	self:set_enemy_assigned(area, unit:key())
end)