local level_id = Global.level_data and Global.level_data.level_id or ""
local difficulty = Global.game_settings and Global.game_settings.difficulty or "easy"

local function isTutorialHeist()
	if level_id == "short1_stage1" then
		return true
	elseif level_id == "short1_stage2" then
		return true
	elseif level_id == "short2_stage1" then
		return true
	elseif level_id == "short2_stage2b" then
		return true
	end
	
	return false
end

Hooks:PostHook(PlayerTweakData, "init", "pd3_init_playerdata", function(self)
	if not isTutorialHeist() then
		if difficulty == "overkill_145" or difficulty == "easy_wish" then
			self.alarm_pager.bluff_success_chance = {1,1,0,0,0}
			self.alarm_pager.bluff_success_chance_w_skill = {1,1,0,0,0}
		elseif difficulty == "overkill_290" or difficulty == "sm_wish" then
			self.alarm_pager.bluff_success_chance = {1,0,0,0,0}
			self.alarm_pager.bluff_success_chance_w_skill = {1,0,0,0,0}
		else
			self.alarm_pager.bluff_success_chance = {1,1,1,1,0}
			self.alarm_pager.bluff_success_chance_w_skill = {1,1,1,1,0}
		end
	else
		-- We're playing tutorials
		self.alarm_pager.bluff_success_chance = {1,1,1,1,0}
		self.alarm_pager.bluff_success_chance_w_skill = {1,1,1,1,0}
	end
	
	if Global.game_settings and Global.game_settings.single_player then
		self.max_nr_following_hostages = 4
	else
		self.max_nr_following_hostages = 2
	end
end)